unit Unit1;

{$mode objfpc}{$H+}
{$modeswitch objectivec1}
interface

uses
  Classes, SysUtils, Forms, Controls, Graphics, Dialogs, StdCtrls, ExtCtrls,
  ComCtrls, ucaltile, MacOSAll, CocoaAll, Cocoa_Extra;

type

  { TForm1 }

  TForm1 = class(TForm)
    Button1: TButton;
    FlowPanel1: TFlowPanel;
    Panel1: TPanel;
    ScrollBox1: TScrollBox;

    procedure Button1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    MyCalTileCount: integer;
    FToolbar: NSToolbar;
  public

  end;

  { TToolbarDelegate }
   TToolbarDelegate = objcclass(NSObject, NSToolbarDelegateProtocol)
     function toolbar_itemForItemIdentifier_willBeInsertedIntoToolbar(toolbar: NSToolbar; itemIdentifier: NSString; flag: boolean): NSToolbarItem; message 'toolbar:itemForItemIdentifier:willBeInsertedIntoToolbar:';
     function toolbarAllowedItemIdentifiers(toolbar: NSToolbar): NSArray; message 'toolbarAllowedItemIdentifiers:';
   end;


var
  Form1: TForm1;

implementation

{$R *.lfm}

{ TForm1 }

procedure TForm1.Button1Click(Sender: TObject);
var
  myCalTile: TFrame1;
  myCalName: string;
begin
  Inc(MyCalTileCount);
  myCalName := 'CalTile' + IntToStr(MyCalTileCount);
  myCaltile := TFrame1.Create(self);
  myCalTile.Name := myCalName;
  myCalTile.Parent := FlowPanel1;
end;



procedure TForm1.FormCreate(Sender: TObject);
var
  Window: NSWindow;
  FToolbarDelegate: TToolbarDelegate;

   addToolbarItem, removeToolbarItem: NSToolbarItem;
begin
  MyCalTileCount := 0;
  Window := NSView(self.Handle).window;
       // Instantiate the delegate
  FToolbarDelegate := TToolbarDelegate.alloc.init;


  // Initialize the toolbar and set the delegate
  FToolbar := NSToolbar.alloc.initWithIdentifier(NSSTR('mainToolbar'));
     FToolbar.setDelegate(FToolbarDelegate);

  FToolbar.setAllowsUserCustomization(True);
  FToolbar.setAutosavesConfiguration(True);


  // Hinzufügen der Toolbar-Items
  addToolbarItem := FToolbarDelegate.toolbar_itemForItemIdentifier_willBeInsertedIntoToolbar(FToolbar, NSSTR('addToolbarItem'), True);
  removeToolbarItem := FToolbarDelegate.toolbar_itemForItemIdentifier_willBeInsertedIntoToolbar(FToolbar, NSSTR('removeToolbarItem'), True);

  // Add the toolbar to the window
  Window.setToolbar(FToolbar);


end;


{ TToolbarDelegate }
function TToolbarDelegate.toolbar_itemForItemIdentifier_willBeInsertedIntoToolbar(toolbar: NSToolbar; itemIdentifier: NSString; flag: boolean): NSToolbarItem;
var
  toolbarItem: NSToolbarItem;
begin
  toolbarItem := NSToolbarItem.alloc.initWithItemIdentifier(itemIdentifier);

  if itemIdentifier.isEqualToString(NSSTR('addToolbarItem')) then
  begin
    toolbarItem.setLabel(NSSTR('Add'));
    toolbarItem.setToolTip(NSSTR('Add a new item'));
    toolbarItem.setImage(NSImage.imageNamed(NSSTR('NSImageNameAddTemplate')));

  end
  else if itemIdentifier.isEqualToString(NSSTR('removeToolbarItem')) then
  begin
    toolbarItem.setLabel(NSSTR('Remove'));
    toolbarItem.setToolTip(NSSTR('Remove selected item'));
    toolbarItem.setImage(NSImage.imageNamed(NSSTR('NSImageNameRemoveTemplate'))); // Minus-Symbol
  end;

  Result := toolbarItem;
end;

function TToolbarDelegate.toolbarAllowedItemIdentifiers(toolbar: NSToolbar): NSArray;
begin
  Result := NSArray.arrayWithObjects(
    NSSTR('addToolbarItem'),
    NSSTR('removeToolbarItem'),
    nil); // Fügen Sie hier weitere Identifier hinzu, falls nötig
end;


end.
